#include <M5Stack.h>
#include <WiFi.h>

const char* ssid = "XXXXXXXXXXXXXXX";     //←変更箇所
const char* password = "YYYYYYYYYYYYYYY"; //←変更箇所
const char* ntpServer = "ntp.nict.jp";
const long gmtOffset_sec = 3600 * 9;
const int daylightOffset_sec = 0;

void printLocalTime() {
  struct tm timeInfo;
  if (getLocalTime(&timeInfo)) {
    M5.Lcd.setCursor(0, 15);
    M5.Lcd.printf("Data: %04d/%02d/%02d\n", timeInfo.tm_year + 1900,
                  timeInfo.tm_mon + 1, timeInfo.tm_mday);
    M5.Lcd.printf("Week: %d\n", timeInfo.tm_wday);
    M5.Lcd.printf("Time: %02d : %02d : %02d\n", timeInfo.tm_hour,
                  timeInfo.tm_min, timeInfo.tm_sec);
  }
}

void setup() {
  // M5Stackを初期化します
  M5.begin();

  M5.Lcd.fillScreen(BLACK);
  M5.Lcd.setTextSize(1);
  M5.Lcd.setCursor(40, 0, 2);
  M5.Lcd.println("CLOCK TEST");

  // Wi-Fi接続
  Serial.println("Connecting to " + String(ssid));
  WiFi.begin(ssid, password);
  // Wi-Fi接続が完了するまで待機します
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println(" CONNECTED");

  //初期化、時刻の取得
  configTime(gmtOffset_sec, daylightOffset_sec, ntpServer);
  //時刻を画面に表示します
  printLocalTime();

  // Wi-Fi接続を切断します
  WiFi.disconnect(true);
  WiFi.mode(WIFI_OFF);
}

void loop() {
  // 0.5秒毎に画面に表示する時刻を更新します
  printLocalTime();
  delay(500);
}
