#include "BluetoothSerial.h"
#include <M5StickC.h>

#define LedPin 10

BluetoothSerial SerialBT;
int mode = 0;

void setup(void) {
  // M5StickCを初期化します
  M5.begin();
  M5.Lcd.setRotation(3);
  M5.Lcd.setTextSize(1);

  // BluetoothのMACアドレスを取得します
  uint8_t macBT[6];
  esp_read_mac(macBT, ESP_MAC_BT);
  //液晶画面にMACアドレスを表示します
  M5.Lcd.print("BT MAC: ");
  M5.Lcd.printf("%02X:%02X:%02X:%02X:%02X:%02X\r\n", macBT[0], macBT[1], macBT[2], macBT[3], macBT[4], macBT[5]);

  // Bluetoothシリアルデバイスを開始します。
  SerialBT.begin("M5BTSerial_slave"); // Bluetooth device name
  Serial.println("The device started, now you can pair it with bluetooth!");

  pinMode(LedPin, OUTPUT);
}

void loop() {
  //シリアルでメッセージを受信した場合
  if (Serial.available()) {
    SerialBT.write(Serial.read());
  }
  // Bluetoothシリアル経由でメッセージを受信した場合
  if (SerialBT.available()) {
    char c = SerialBT.read();
    Serial.write(c);
    /*受信メッセージが1：LED点滅
     *受信メッセージが2：LED点灯
     *受信メッセージが3：LED消灯*/
    if (c == '1') {
      mode = 1;
    } else if (c == '2') {
      mode = 2;
    } else if (c == '3') {
      mode = 3;
    }
  }
  if (mode == 1) {
    digitalWrite(LedPin, 0);
    delay(1000);
    digitalWrite(LedPin, 1);
    delay(1000);
  } else if (mode == 2) {
    digitalWrite(LedPin, 0);
  } else if (mode == 3) {
    digitalWrite(LedPin, 1);
  }
  delay(20);
}
