#include "BluetoothSerial.h"
#include <M5Stack.h>

BluetoothSerial SerialBT;

uint8_t slaveMAC[6] = {0x01, 0x02, 0x03, 0x04, 0x05, 0x06}; //←変更箇所
bool connected;

void setup() {
  // M5StackまたはM5StickCを初期化します
  M5.begin();

  // Bluetoothシリアルデバイスを開始します。
  SerialBT.begin("M5BTSerial", true);

  //接続
  while (!SerialBT.hasClient()) {
    Serial.println("Connecting... Make sure remote device is available and in range.");
    M5.Lcd.println("Connecting...");
    if (!SerialBT.connect(slaveMAC)) {
      while(!SerialBT.connected(10000)) {
      }
    }
  }
  Serial.println("Connected Successfully!");
  M5.Lcd.println("Connected Successfully!");
}

void loop() {
  //シリアルでメッセージを受信した場合
  if (Serial.available()) {
    char c = Serial.read();
    M5.Lcd.print(String(c));
    Serial.print(String(c));
    SerialBT.write(c);
  }
  // Bluetoothシリアル経由でメッセージを受信した場合
  if (SerialBT.available()) {
    Serial.write(SerialBT.read());
  }
  //通信相手がいなくなった場合に再接続します
  if (!SerialBT.hasClient()) {
    while (!SerialBT.hasClient()) {
      Serial.println("Reconnecting... Make sure remote device is available and in range.");
      M5.Lcd.println("Reconnecting...");
      if (!SerialBT.connect(slaveMAC)) {
        while(!SerialBT.connected(10000)) {
        }
      }
    }
    Serial.println("Reconnected Successfully!");
    M5.Lcd.println("Reconnected Successfully!");
  }
  delay(20);
}
