#include <M5Stack.h>
#include <URLEncoding.h>
#include <WiFi.h>
#include <WiFiClient.h>

const char* ssid = "XXXXXXXXXXXXXXX"; //←変更箇所
const char* password = "YYYYYYYYYYYYYYY"; //←変更箇所

String makerEvent = "m5button_pressed"; // Event Nameを入力
String makerKey = "ZZZZZZZZZZZZZZZ";    // makerkey

const char* server = "maker.ifttt.com"; //IFTTTのURL
WiFiClient client;

// IFTTTにデータを送信する関数です。
void send(String value1, String value2, String value3) {
  //サーバーを起動
  Serial.println("\nStarting connection to server...");
  if (!client.connect(server, 80)) {
    Serial.println("Connection failed!");
  } else {
    Serial.println("Connected to server!");
    //送信先のURLを作成
    String url = "/trigger/" + makerEvent + "/with/key/" + makerKey;
    url += "?value1=" + urlEncode(value1)
    + "&value2=" + urlEncode(value2)
    + "&value3=" + urlEncode(value3);
    // URLリクエストを送信
    client.println("GET " + url + " HTTP/1.1");
    client.print("Host: ");
    client.println(server);
    client.println("Connection: close");
    client.println();
    Serial.print("Waiting for response ");

    int count = 0;
    while (!client.available()) {
      delay(50);
      Serial.print(".");
    }
    //サーバーからのレスポンスを読み込んでシリアルに出力
    while (client.available()) {
      char c = client.read();
      Serial.write(c);
    }

    //サーバーとの通信を終了
    if (!client.connected()) {
      Serial.println();
      Serial.println("disconnecting from server.");
      client.stop();
    }
  }
}

void setup() {
  // M5Stack or M5StickCを初期化
  M5.begin();

  M5.Power.begin();

  M5.Lcd.fillScreen(BLACK);
  M5.Lcd.setCursor(40, 0, 2);
  M5.Lcd.println("LINE NOTIFY");

  // Wi-Fi接続
  Serial.println("Connecting to " + String(ssid));
  WiFi.begin(ssid, password);
  // Wi-Fi接続が完了するまで待機
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println(" CONNECTED");

  M5.Lcd.setTextSize(2);
}

void loop() {
  M5.update();
  M5.Lcd.setCursor(0, 15);

  if(M5.BtnA.wasReleased()){
    // LINEに送信したいメッセージを3つ指定
    M5.Lcd.println("Hello, Line from M5Stack!");
    send("Hello, ", "Line ", "from M5Stack!");
  } else if (M5.BtnB.wasReleased()){
    // LINEに電池残量を送信
    String vbat_p;
    if(!M5.Power.canControl()) {
      vbat_p = String(M5.Power.getBatteryLevel());
    } else { //電源情報が取得できない古いM5Stack
      vbat_p = "??";
    }

    M5.Lcd.println(String(vbat_p) + "% / 100% ");
    send("Battery(%): ", String(vbat_p), "% / 100%");
  }
  delay(20);
}
